SystemOrganization addCategory: #Slot!
SystemOrganization addCategory: #'Slot-ClassBuilder'!
SystemOrganization addCategory: #'Slot-Layout'!
SystemOrganization addCategory: #'Slot-Transformation'!

!TraitTransformation methodsFor: '*Slot' stamp: 'ToonVerwaest 3/31/2011 23:03'!
composeWithLayout: aLayout
	^ subject composeWithLayout: aLayout! !

!ByteString methodsFor: '*Slot' stamp: 'ToonVerwaest 4/1/2011 03:57'!
asSlot
	^ self asSymbol asSlot! !

!String methodsFor: '*Slot' stamp: 'MartinDias 8/7/2012 22:01'!
asSlotCollection
	"Parse as slots.
	Example: 
	  'a b' asSlotCollection --> {a => Slot. b => Slot}
	"
	^ (self subStrings: ' ') collect: [ :x | x asSlot ]! !

!TraitComposition methodsFor: '*Slot' stamp: 'ToonVerwaest 4/2/2011 20:49'!
composeWithLayout: aLayout
	| result |
	result := aLayout.
	transformations do: [ :aTransformation |
		result := aTransformation composeWithLayout: result ].
	^ result! !

!Symbol class methodsFor: '*Slot' stamp: 'MartinDias 8/7/2012 01:18'!
pseudovariablesNames
	^#('self' 'true' 'false' 'nil' 'thisContext' 'super')! !

!Symbol methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 16:23'!
=> aSlot
	aSlot isBehavior
		ifTrue: [ ^ aSlot named: self].
	^ aSlot name: self;
		yourself! !

!Symbol methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 14:35'!
asSlot
	^ Slot named: self.! !

!Symbol methodsFor: '*Slot' stamp: 'MartinDias 8/7/2012 01:31'!
isPseudovariableName
	"Answer true if I am a pseudo-variable name.
	#self isPseudovariableName -> true
	"
	^ self class pseudovariablesNames includes: self! !

Error subclass: #SlotNotFound
	instanceVariableNames: 'name targetClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!SlotNotFound commentStamp: '<historical>' prior: 0!
I am an exception to indicate that a slot is found in a layout.!

!SlotNotFound class methodsFor: 'signalling' stamp: 'CAmi 3/15/2011 18:53'!
signalForName: aSymbol
	self new
		name: aSymbol;
		signal! !

!SlotNotFound class methodsFor: 'signalling' stamp: 'CAmi 3/15/2011 18:55'!
signalForName: aSymbol inClass: aClass
	self new
		name: aSymbol;
		targetClass: aClass;
		signal! !

!SlotNotFound methodsFor: 'accessing' stamp: 'CamilloBruni 3/23/2011 14:22'!
messageText
	^ 'Slot ''', name asString, ''' not found', (targetClass ifNil: [''] ifNotNil:[' in ', targetClass name])! !

!SlotNotFound methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:54'!
name
	^ name! !

!SlotNotFound methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:54'!
name: anObject
	name := anObject! !

!SlotNotFound methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:55'!
targetClass
	^ targetClass! !

!SlotNotFound methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 18:54'!
targetClass: aClass
	targetClass := aClass! !

!TraitDescription methodsFor: '*Slot' stamp: 'ToonVerwaest 3/31/2011 23:04'!
composeWithLayout: aLayout
	" Standard traits don't have any state "
	^ aLayout! !

Exception subclass: #SlotClassBuilderConflict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!SlotClassBuilderConflict commentStamp: '<historical>' prior: 0!
I represent an error raised while building a class.!

SlotClassBuilderConflict subclass: #CircularHierarchyConflict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!CircularHierarchyConflict commentStamp: '<historical>' prior: 0!
I am signaled if a new class introduces a circular class hierarchy.!

SlotClassBuilderConflict subclass: #InvalidGlobalNameConflict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!InvalidGlobalNameConflict commentStamp: '<historical>' prior: 0!
I am an error raised by SlotClassBuilder.!

SlotClassBuilderConflict subclass: #InvalidSlotNameConflict
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!InvalidSlotNameConflict commentStamp: '<historical>' prior: 0!
I am signaled the name of default Slot is an invalid variable name.!

SlotClassBuilderConflict subclass: #PrimitiveTypeConflict
	instanceVariableNames: 'layout subType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!PrimitiveTypeConflict commentStamp: '<historical>' prior: 0!
I am an error raised when extending a class with an incompatible layout.!

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
layout
	^ layout! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
layout: anObject
	layout := anObject! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:30'!
messageText
	^ 'Class with ', layout class name, ' cannot be extended as ', subType! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
subType
	^ subType! !

!PrimitiveTypeConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:28'!
subType: anObject
	subType := anObject! !

!SlotClassBuilderConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:12'!
defaultAction
	"No one has handled this error, but now give them a chance to decide how to debug it.  If none handle this either then open debugger (see UnhandedError-defaultAction)"

	UnhandledError signalForException: self! !

!SlotClassBuilderConflict methodsFor: 'private' stamp: 'ToonVerwaest 3/21/2011 01:13'!
isResumable
	"Determine whether an exception is resumable."

	^ false! !

SlotClassBuilderConflict subclass: #SlotDuplicationConflict
	instanceVariableNames: 'newSlot oldSlot host'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!SlotDuplicationConflict commentStamp: '<historical>' prior: 0!
I am an error raised when generating a duplicated slot.!

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:15'!
host
	^ host! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:15'!
host: anObject
	host := anObject! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:17'!
messageText
	^ 'Slot #''', oldSlot name, ''' appeared twice in ', host name! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
newSlot
	^ newSlot! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
newSlot: anObject
	newSlot := anObject! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
oldSlot
	^ oldSlot! !

!SlotDuplicationConflict methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 01:10'!
oldSlot: anObject
	oldSlot := anObject! !

!Class methodsFor: '*Slot' stamp: 'MartinDias 6/14/2013 18:07'!
subclass: className layoutClass: aLayoutClass slots: slotCollection sharedVariableNames: sharedVariablesString sharedPoolNames: sharedPoolsString category: categoryName
	"This is a message for creating a new class as a subclass of an existing class (the receiver)."

	^ PharoClassInstaller make: [ :builder |
		builder
			superclass: self;
			layoutClass: aLayoutClass;
			name: className;
			slots: slotCollection;
			sharedVariables: sharedVariablesString;
			sharedPools: sharedPoolsString;
			category: categoryName.
			
		"Class-side stuff shouldn't be lost. Probably this is responsibility of class builder."
		Smalltalk at: className ifPresent: [ :oldClass |
			builder 
				classSlots: (oldClass classSide instVarNames collect: [:n | n asSlot ]);
				classTraitComposition: oldClass classSide traitComposition.
				 ].
			]! !

Object subclass: #AbstractClassInstaller
	instanceVariableNames: 'builder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractClassInstaller commentStamp: '<historical>' prior: 0!
I take a ready class and install it in a given environment.
My sublcasses implement custom strategies.!

!AbstractClassInstaller class methodsFor: 'building' stamp: 'ToonVerwaest 3/22/2011 19:12'!
make: aBlock
	| builder |
	builder := self new builder.
	aBlock value: builder.
	^ builder build! !

!AbstractClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:42'!
builder
	^ builder! !

!AbstractClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:43'!
classAdded: aClass inCategory: aCategory
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:44'!
classAt: aName ifAbsent: aBlock
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionDeeplyChangedFrom: oldClass to: newClass by: classModification
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionShallowChangedFrom: oldClass to: newClass by: classModification
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'traits' stamp: 'MartinDias 7/1/2013 14:54'!
copyTraitCompositionFrom: oldClass to: newClass

	self 
		installTraitComposition: oldClass traitComposition copyTraitExpression 
		on: newClass.
	"We have to manually unsubcribe the newClass from its traits. Later in the class-building phase newClass becomeForward: oldClass and hence we can no longer distinguish the two. Which would leave `newClass trait users`, an IdetitySet, in an invalid state, as it's elements have been modified (the becomeForward:) without a proper rehash."
	newClass traitComposition traits do: [ :trait |
		trait removeUser: newClass ].
! !

!AbstractClassInstaller methodsFor: 'accessing' stamp: 'CamilloBruni 6/28/2013 14:03'!
environment
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:45'!
environment: anEnvironment
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/22/2011 17:43'!
initialize
	builder := SlotClassBuilder new.
	builder client: self! !

!AbstractClassInstaller methodsFor: 'traits' stamp: 'MartinDias 6/24/2013 18:25'!
installTraitComposition: aTraitComposition on: aClass
	self flag: 'Should probably send something else to test'.
	aClass setTraitComposition: aTraitComposition! !

!AbstractClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/22/2011 18:30'!
migrateClasses: old to: new using: anInstanceModification
	self subclassResponsibility! !

!AbstractClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:44'!
recategorize: aClass to: aCategory
	self subclassResponsibility! !

AbstractClassInstaller subclass: #AnonymousClassInstaller
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AnonymousClassInstaller commentStamp: '<historical>' prior: 0!
I am a class installer that does not expose the class to the global environment nor announces that a new class has been created.
As it's name suggest it is used for anonymous classes, for instance in Tests.!

!AnonymousClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:45'!
classAdded: aClass inCategory: aCategory! !

!AnonymousClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:46'!
classAt: aName ifAbsent: aBlock
	^ aBlock value! !

!AnonymousClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionDeeplyChangedFrom: oldClass to: newClass by: classModification! !

!AnonymousClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 18:38'!
classDefinitionShallowChangedFrom: oldClass to: newClass by: classModification! !

!AnonymousClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:46'!
environment: anEnvironment! !

!AnonymousClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/22/2011 18:30'!
migrateClasses: old to: new using: anInstanceModification! !

!AnonymousClassInstaller methodsFor: 'notifications' stamp: 'ToonVerwaest 3/22/2011 17:46'!
recategorize: aClass to: aCategory! !

AbstractClassInstaller subclass: #PharoClassInstaller
	instanceVariableNames: 'environment instanceModification methodUpdateStrategy'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!PharoClassInstaller commentStamp: '<historical>' prior: 0!
I am the default class installer.
I install a new or modified class in the globals dictionary and announce this change publicly.

The default environment can be changed to any SystemDictionary.

Example:
	PharoClassInstaller example!

!PharoClassInstaller class methodsFor: 'example' stamp: 'MartinDias 7/1/2013 16:10'!
example
	^ PharoClassInstaller make: [ :aSlotClassBuilder |
		aSlotClassBuilder
			superclass: Object;
			name: #MyClass;
			slots: #(varA varB);
			category: 'My-Category' ].! !

!PharoClassInstaller class methodsFor: 'testing' stamp: 'MartinDias 11/6/2012 11:32'!
validateClassName: aString
	"Validate if a string can be the name of a new class. Raise an error if not."
	
	self new builder name: aString.! !

!PharoClassInstaller methodsFor: 'private' stamp: 'MartinDias 6/28/2013 17:45'!
basicClassDefinitionChangedFrom: oldClass to: newClass

    " Copy over the trait composition "
    self copyTraitCompositionFrom: oldClass to: newClass.        
    " Copy over the method organization "
    newClass organization: oldClass organization.    
    " Update the superclass links "
    oldClass superclass == newClass superclass
        ifFalse: [ 
            oldClass superclass removeSubclass: oldClass.
            newClass superclass addSubclass: newClass ].

    self systemAnnouncer classDefinitionChangedFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'MartinDias 6/28/2013 12:50'!
classAdded: aClass inCategory: aCategory
	" Install the new class in the system "
	environment at: aClass name put: aClass.
	environment flushClassNameCache.
	
	" Update the system's organization "
	environment organization classify: aClass name under: aCategory.
	aClass environment: environment.
	
	self systemAnnouncer classAdded: aClass inCategory: aCategory.
	" Inform superclass of new subclass "
	aClass superclass addSubclass: aClass.! !

!PharoClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 17:03'!
classAt: aName ifAbsent: aBlock
	^ (environment at: aName ifAbsent: aBlock)
		ifNil: aBlock! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'MartinDias 7/1/2013 15:55'!
classDefinitionChangedFrom: oldClass to: newClass by: classModification
	
	^ self
		copyMethodsFrom: oldClass to: newClass using: classModification;
		basicClassDefinitionChangedFrom: oldClass to: newClass.! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'MartinDias 7/30/2012 00:08'!
copyMethodsFrom: oldClass to: newClass using: classModification
	methodUpdateStrategy
		transform: oldClass
		to: newClass
		using: classModification methodModification! !

!PharoClassInstaller methodsFor: 'accessing' stamp: 'CamilloBruni 6/28/2013 14:03'!
environment
	^ environment! !

!PharoClassInstaller methodsFor: 'accessing' stamp: 'ToonVerwaest 3/22/2011 16:55'!
environment: anEnvironment
	environment := anEnvironment! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'MartinDias 7/1/2013 15:56'!
formatChangedFrom: oldClass to: newClass by: classModification

	self 
		classDefinitionChangedFrom: oldClass 
		to: newClass 
		by: classModification
	! !

!PharoClassInstaller methodsFor: 'initialize-release' stamp: 'MartinDias 7/30/2012 00:03'!
initialize
	super initialize.
	environment := nil environment.
	methodUpdateStrategy := MethodRecompileStrategy new.! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'MartinDias 7/1/2013 15:58'!
migrateClasses: old to: new using: anInstanceModification
	instanceModification := anInstanceModification.
	old ifEmpty:  [ ^ self ].
	[
		1 to: old size do: [ :index |
			self updateClass: (old at: index) to: (new at: index)].
		old elementsForwardIdentityTo: new.
		" Garbage collect away the zombie instances left behind in garbage memory in #updateInstancesFrom: "
		" If we don't clean up this garbage, a second update would revive them with a wrong layout!! "
		" (newClass rather than oldClass, since they are now both newClass) "
		Smalltalk garbageCollect.
	] valueUnpreemptively! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'MartinDias 7/1/2013 15:56'!
recategorize: aClass to: newCategory
	| oldCategory |
	
	oldCategory := aClass category.
	oldCategory == newCategory  
		ifTrue: [ ^ self ].
		
	environment organization 
		classify: aClass name 
		under: newCategory.
		
	self systemAnnouncer 
		class: aClass 
		recategorizedFrom: oldCategory 
		to: newCategory! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'MartinDias 7/1/2013 15:55'!
shallowClassDefinitionChangedFrom: oldClass to: newClass by: classModification
	" Copy over the method organization "
	" Update the superclass links "
	self 
		shallowCopyMethodsFrom: oldClass to: newClass using: classModification;
		basicClassDefinitionChangedFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'ToonVerwaest 3/22/2011 18:54'!
shallowCopyMethodsFrom: oldClass to: newClass using: classModification
	newClass methodDict: oldClass methodDict! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'MartinDias 7/1/2013 15:55'!
slotsChangedFrom: oldClass to: newClass by: classModification
	
	self
		classDefinitionChangedFrom: oldClass 
		to: newClass 
		by: classModification.! !

!PharoClassInstaller methodsFor: 'notifications' stamp: 'MartinDias 7/1/2013 15:55'!
superclassChangedFrom: oldClass to: newClass by: classModification

	self 
		shallowClassDefinitionChangedFrom: oldClass
		to: newClass
		by: classModification ! !

!PharoClassInstaller methodsFor: 'private' stamp: 'MartinDias 4/26/2013 17:07'!
systemAnnouncer
	^ SystemAnnouncer uniqueInstance! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'MartinDias 7/1/2013 15:59'!
updateClass: oldClass to: newClass
	| compactClassIndex |
	
	compactClassIndex := oldClass indexIfCompact.
	compactClassIndex > 0
		ifTrue: [ newClass layout compactClassIndex: compactClassIndex ].
	
	self updateInstancesFrom: oldClass to: newClass! !

!PharoClassInstaller methodsFor: 'migrating' stamp: 'MartinDias 7/1/2013 15:59'!
updateInstancesFrom: old to: new
	| oldInstances variable instSize newInstances map |
	
	oldInstances := old allInstances asArray.
	variable := new isVariable.
	instSize := new instSize.
	newInstances := Array new: oldInstances size.
	map := new instVarMappingFrom: old.
	
	1 to: oldInstances size do: [ :i |
		newInstances at: i put: (
			new newInstanceFrom: (oldInstances at: i) 
				 variable: variable 
				 size: instSize 
				 map: map) ].
	
	oldInstances elementsForwardIdentityTo: newInstances.! !

Object subclass: #AbstractClassModification
	instanceVariableNames: 'target layout propagations newClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractClassModification commentStamp: '<historical>' prior: 0!
I represent a class modification. 

I content field modifications.!

!AbstractClassModification methodsFor: 'public' stamp: 'ToonVerwaest 4/1/2011 17:49'!
apply
	^ newClass := target shallowCopy
		superclass: self superclass
		layout: layout! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'CamilloBruni 3/30/2011 19:27'!
checkSanity
	layout checkSanity.! !

!AbstractClassModification methodsFor: 'private' stamp: 'ToonVerwaest 3/21/2011 01:20'!
computeChange
	self checkSanity.! !

!AbstractClassModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 03:31'!
initialize
	propagations := OrderedCollection new.! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 13:50'!
layout
	^ layout! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'MartinDias 4/12/2013 13:01'!
layout: aLayout
	layout := aLayout.
	layout host: target.
	layout finalize.
	layout = target layout 
		ifFalse: [ self computeChange ]! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:49'!
newClass
	^ newClass! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:24'!
newLayout
	^ layout! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:38'!
oldLayout
	^ target layout! !

!AbstractClassModification methodsFor: 'private' stamp: 'MartinDias 7/8/2013 17:03'!
propagate
	target subclassesDo: [ :subclass |
		propagations add:
			(ClassModificationPropagation
				propagate: self
				to: subclass) ].
	"recursively propagate this change down"
	self propagationsDo: [ :propagation | propagation propagate ]
	
		! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:19'!
propagationsDo: aBlock
	propagations do: [ :aPropagation |
		aBlock value: aPropagation.
		aPropagation propagationsDo: aBlock ]! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 19:53'!
result
	^ target! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 19:40'!
target
	^ target! !

!AbstractClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/19/2011 15:57'!
target: aTarget
	target := aTarget! !

AbstractClassModification subclass: #ClassModification
	instanceVariableNames: 'ownSlotStart superclass additions removals changes subclassSlotOffset slotShift methodModification copies traitComposition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!ClassModification commentStamp: '<historical>' prior: 0!
I represent a modification in a class. !

!ClassModification class methodsFor: 'instance creation' stamp: 'MartinDias 7/30/2012 01:28'!
modify: aClass extend: aSuperclass withLayoutType: layoutClass slots: someSlots traitComposition: aTraitComposition
	^ self new
		target: aClass;
		superclass: aSuperclass;
		traitComposition: aTraitComposition;
		layoutType: layoutClass	slots: someSlots! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:30'!
additions: aCollection
	additions := aCollection! !

!ClassModification methodsFor: 'private' stamp: 'CamilloBruni 3/29/2011 19:00'!
buildModificationMapFor: aModification
	aModification slotShift: (ShiftedField new shift: slotShift).
	
	aModification size = 0 
		ifTrue: [ ^ aModification ].
	
	additions do: [ :slot | 
		self installSlotAddition: slot on: aModification].
	
	changes keysAndValuesDo: [ :newSlot :oldSlot | 
		self installSlotChangeFrom: oldSlot to: newSlot on: aModification ].
	
	removals do: [ :slot | 
		self installSlotRemoval: slot on: aModification].
	
	copies keysAndValuesDo: [ :newSlot :oldSlot | 
		self installSlotCopiedFrom: oldSlot to: newSlot on: aModification ].
	
	^ aModification! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 15:49'!
changes
	^ changes! !

!ClassModification methodsFor: 'private' stamp: 'ToonVerwaest 4/3/2011 11:21'!
computeChange
	super computeChange.
	layout computeChangesFrom: target layout in: self.
	slotShift := layout fieldSize - target layout fieldSize.
	self propagate.! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:45'!
copies
	^ copies! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/21/2011 02:00'!
formatChange
	^ (layout format = target layout format) not! !

!ClassModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 03:31'!
initialize
	super initialize.
	changes := IdentityDictionary new.
	copies := IdentityDictionary new.
	removals := {}.
	additions := {}.! !

!ClassModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 20:02'!
installSlotAddition: slot on: aModification
	0 to: slot size - 1 do: [ :idx |
		(AddedField new
			newSlot: slot;
			fieldIndex: idx) installOn: aModification  ]! !

!ClassModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 20:02'!
installSlotChangeFrom: oldSlot to: newSlot on: aModification
	0 to: newSlot size - 1 do: [ :idx |
 		(ModifiedField new
			newSlot: newSlot;
			originalSlot: oldSlot;
			fieldIndex: idx) installOn: aModification ]! !

!ClassModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/30/2011 13:41'!
installSlotCopiedFrom: oldSlot to: newSlot on: aModification
	0 to: newSlot size - 1 do: [ :idx |
 		(UnmodifiedField new
			slot: newSlot;
			fieldIndex: idx) installOn: aModification ]! !

!ClassModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 20:02'!
installSlotRemoval: slot on: aModification
	0 to: slot size - 1 do: [ :idx |
		(RemovedField new
			originalSlot: slot;
			fieldIndex: idx) installOn: aModification ]! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 02:45'!
instanceModification
	| map |
	map := InstanceModification new: layout fieldSize.
	^ self buildModificationMapFor: map! !

!ClassModification methodsFor: 'accessing' stamp: 'MartinDias 7/30/2012 01:30'!
layoutType: layoutType slots: slotArray
	| parentLayout newScope |
	parentLayout := self parentLayout.
	newScope := parentLayout slotScope extend: slotArray.
	self layout: (layoutType buildFrom: parentLayout scope: newScope host: self target)! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 02:27'!
methodModification
	^ methodModification ifNil: [
		methodModification := MethodModification new: target layout fieldSize.
		self buildModificationMapFor: methodModification ]! !

!ClassModification methodsFor: 'testing' stamp: 'ToonVerwaest 3/31/2011 21:17'!
modifiesFormat
	^ (layout format = target layout format) not! !

!ClassModification methodsFor: 'testing' stamp: 'ToonVerwaest 3/30/2011 15:31'!
modifiesSlots
	^ (changes isEmpty and: [ removals isEmpty and: [ additions isEmpty ]]) not! !

!ClassModification methodsFor: 'testing' stamp: 'CamilloBruni 3/24/2011 23:56'!
modifiesSuperclass
	^ (target superclass == superclass) not! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:04'!
newScope
	^ layout slotScope! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:03'!
originalScope
	^ target layout slotScope! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:15'!
parentLayout
	^ traitComposition composeWithLayout: self superLayout! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:30'!
removals: aCollection
	removals := aCollection! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 23:32'!
slotShift
	^ slotShift! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 15:25'!
subclassSlotOffset
	^ subclassSlotOffset! !

!ClassModification methodsFor: 'accessing' stamp: 'MartinDias 6/24/2013 16:54'!
superLayout
	^ superclass
		ifNil: [ EmptyLayout instance ]
		ifNotNil: [ superclass layout ]! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 19:34'!
superclass
	^ superclass! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/20/2011 14:32'!
superclass: aClass
	superclass := aClass! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 19:48'!
traitComposition
	^ traitComposition! !

!ClassModification methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 20:54'!
traitComposition: aTraitComposition
	" We copy the trait composition since we might want "
	" to update the slot indices if the composition is partly stateful "
	traitComposition := aTraitComposition copyTraitExpression! !

AbstractClassModification subclass: #ClassModificationPropagation
	instanceVariableNames: 'origin'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!ClassModificationPropagation commentStamp: '<historical>' prior: 0!
I am a propagation to subclasses of a modification in a class.!

!ClassModificationPropagation class methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/20/2011 14:51'!
propagate: aModification to: aClass
	^ self new
		propagate: aModification
		to: aClass! !

!ClassModificationPropagation methodsFor: 'migrating' stamp: 'ToonVerwaest 3/27/2011 21:14'!
methodModification
	^ origin methodModification! !

!ClassModificationPropagation methodsFor: 'public' stamp: 'ToonVerwaest 4/1/2011 18:16'!
propagate: aModification to: aTarget
	origin := aModification.
	target := aTarget.
	self layout: (target layout reshapeFrom: origin oldLayout slotScope to: origin newLayout).! !

!ClassModificationPropagation methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 17:50'!
superclass
	^ origin newClass! !

Object subclass: #AbstractFieldModification
	instanceVariableNames: 'fieldIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractFieldModification commentStamp: '<historical>' prior: 0!
I am an abstract field modification.
Field modifications encapsulate the changes required to migrated instances.!

!AbstractFieldModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
fieldIndex
	^ fieldIndex! !

!AbstractFieldModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
fieldIndex: anObject
	fieldIndex := anObject! !

!AbstractFieldModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:07'!
installOn: aModification
	self subclassResponsibility! !

!AbstractFieldModification methodsFor: 'migrating' stamp: 'ToonVerwaest 3/28/2011 20:31'!
migrateAt: index to: newInstance from: oldInstance! !

AbstractFieldModification subclass: #AddedField
	instanceVariableNames: 'newSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AddedField commentStamp: '<historical>' prior: 0!
I represent the change of a newly added field on an instance.!

!AddedField methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:07'!
installOn: aModification
	aModification installAddedSlot: self! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 19:48'!
name
	^ newSlot name! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
newFieldIndex
	^ newSlot index + fieldIndex! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:35'!
newSlot
	^ newSlot! !

!AddedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:35'!
newSlot: anObject
	newSlot := anObject! !

AbstractFieldModification subclass: #ModifiedField
	instanceVariableNames: 'newSlot originalSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!ModifiedField commentStamp: '<historical>' prior: 0!
I encapsulate the modification of a slot.
The two use-cases are: slot renaming or a changed slot type.
Both cases enforce recompilation of all the methods accessing the corresponding variable.

This is unlike the ShiftedField modification which is only used when the type of the slot does not change.!

!ModifiedField methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:08'!
installOn: aModification
	aModification installModifiedSlot: self! !

!ModifiedField methodsFor: 'migrating' stamp: 'ToonVerwaest 3/30/2011 13:54'!
migrateAt: index to: newInstance from: oldInstance
	newInstance
		instVarAt: index
		put: (oldInstance instVarAt: self oldFieldIndex)! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
newFieldIndex
	^ newSlot index + fieldIndex! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
newSlot
	^ newSlot! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
newSlot: anObject
	newSlot := anObject! !

!ModifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
oldFieldIndex
	^ originalSlot index + fieldIndex! !

!ModifiedField methodsFor: 'accessing' stamp: 'CamilloBruni 3/28/2011 18:50'!
originalSlot

	^ originalSlot! !

!ModifiedField methodsFor: 'accessing' stamp: 'CamilloBruni 3/28/2011 18:50'!
originalSlot: anObject
	originalSlot := anObject! !

AbstractFieldModification subclass: #RemovedField
	instanceVariableNames: 'originalSlot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!RemovedField commentStamp: '<historical>' prior: 0!
I represent the change of a removed field on an instance.!

!RemovedField methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:08'!
installOn: aModification
	aModification installRemovedSlot: self! !

!RemovedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:19'!
oldFieldIndex
	^ originalSlot index + fieldIndex! !

!RemovedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
originalSlot
	^ originalSlot! !

!RemovedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 16:34'!
originalSlot: anObject
	originalSlot := anObject! !

AbstractFieldModification subclass: #ShiftedField
	instanceVariableNames: 'shift'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!ShiftedField commentStamp: '<historical>' prior: 0!
I represent the change of a shifted field on an instance.
The old field and the new field correspond to the same Slot.

In terms of method migration, it is only necessary to update the index of direct accessors/bytecodes to instance variable.!

!ShiftedField methodsFor: 'migrating' stamp: 'MartinDias 6/24/2013 18:04'!
migrateAt: index to: newInstance from: oldInstance
	newInstance 
		instVarAt: index 
		put: (oldInstance instVarAt: index - shift)! !

!ShiftedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 20:27'!
shift
	^ shift! !

!ShiftedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 20:27'!
shift: anObject
	shift := anObject! !

AbstractFieldModification subclass: #UnmodifiedField
	instanceVariableNames: 'slot'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!UnmodifiedField commentStamp: '<historical>' prior: 0!
Ceci n'est pas une modifications.
I am used to migrate non modified fields from the old to the new instance.
Typically I am used when only certain fields are modified and others are left as is.!

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:27'!
fieldIndex
	^ slot index + fieldIndex! !

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:28'!
installOn: aModification
	aModification installUnmodifiedSlot: self! !

!UnmodifiedField methodsFor: 'migrating' stamp: 'ToonVerwaest 3/30/2011 13:55'!
migrateAt: index to: newInstance from: oldInstance
	newInstance
		instVarAt: index
		put: (oldInstance instVarAt: index)! !

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:48'!
slot
	^ slot! !

!UnmodifiedField methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 17:48'!
slot: anObject
	slot := anObject! !

Object subclass: #AbstractLayout
	instanceVariableNames: 'host'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!AbstractLayout commentStamp: '<historical>' prior: 0!
I'm a container for slots.

There are special cases of layouts without slots, like NilLayout or BitsLayout.!

!AbstractLayout methodsFor: 'comparing' stamp: 'MartinDias 4/12/2013 13:15'!
= other
	^ self class = other class! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/3/2011 22:58'!
allSlots
	^ {}! !

!AbstractLayout methodsFor: 'enumerating' stamp: 'MartinDias 8/7/2012 00:42'!
allSlotsDo: aBlock
	self slotScope allSlotsDo: aBlock! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 19:07'!
allVisibleSlots
	^ {}! !

!AbstractLayout methodsFor: 'validation' stamp: 'MartinDias 7/8/2013 17:22'!
checkIntegrity
	self checkSanity! !

!AbstractLayout methodsFor: 'validation' stamp: 'ToonVerwaest 4/1/2011 03:38'!
checkSanity
	host ifNil: [ self error: 'Host should not be nil' ].! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
fieldSize
	^ 0! !

!AbstractLayout methodsFor: 'finalization' stamp: 'ToonVerwaest 4/7/2011 12:08'!
finalize
	self allSlotsDo: [ :aSlot | aSlot finalize: self ]! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
hasFields
	^ false! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
hasSlots
	^ false! !

!AbstractLayout methodsFor: 'comparing' stamp: 'MartinDias 4/12/2013 13:20'!
hash
	^ self class hash! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:52'!
host
	^ host! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:52'!
host: anObject
	host := anObject! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 03:38'!
instanceVariables
	^ {}! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
isBits
	^ false! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
isVariable
	^ false! !

!AbstractLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 03:37'!
isWeak
	^ false! !

!AbstractLayout methodsFor: 'printing' stamp: 'ToonVerwaest 4/1/2011 03:39'!
printSlotDefinitionOn: aStream
	aStream << '{}'! !

!AbstractLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/7/2011 12:10'!
resolveSlot: aName
	self flag: 'Signal rather than error'.
	self error: 'No slots found'! !

!AbstractLayout methodsFor: 'accessing' stamp: 'MartinDias 8/6/2012 22:31'!
slotScope
	^ LayoutEmptyScope instance! !

AbstractLayout subclass: #EmptyLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

EmptyLayout class
	instanceVariableNames: 'instance'!

!EmptyLayout commentStamp: '<historical>' prior: 0!
Empty top-level layout used to delimit the layout chains.!

EmptyLayout class
	instanceVariableNames: 'instance'!

!EmptyLayout class methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/20/2011 15:29'!
instance
	^ instance ifNil: [ instance := self new ]! !

!EmptyLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 14:26'!
extend: someSlots
	^ PointerLayout new
		slotScope: (LayoutEmptyScope instance extend: someSlots)! !

!EmptyLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:56'!
extendByte
	^ ByteLayout new! !

!EmptyLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 14:26'!
extendVariable: someSlots
	^ VariableLayout new
		slotScope: (LayoutEmptyScope extend: someSlots)! !

!EmptyLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:57'!
extendWeak
	^ WeakLayout new! !

!EmptyLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:56'!
extendWord
	^ WordLayout new! !

!EmptyLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 02:06'!
fieldSize
	^ 0! !

!EmptyLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 02:06'!
hasFields
	^ false! !

!EmptyLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 02:06'!
hasSlots
	^ false! !

AbstractLayout subclass: #ObjectLayout
	instanceVariableNames: 'compactClassIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!ObjectLayout commentStamp: '<historical>' prior: 0!
I am the superclass of standard layouts for Objects.!

ObjectLayout subclass: #BitsLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!BitsLayout commentStamp: '<historical>' prior: 0!
I am a specialized layout which does not hold slots but only raw data (bytes or words).!

!BitsLayout methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 01:53'!
initializeInstance: anInstance! !

!BitsLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:25'!
isBits
	^ true! !

!BitsLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:26'!
isVariable
	^ true! !

BitsLayout subclass: #ByteLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!ByteLayout commentStamp: '<historical>' prior: 0!
I am a raw data layout that holds bytes (8 bit).!

!ByteLayout class methodsFor: 'instance creation' stamp: 'MartinDias 8/1/2012 00:27'!
buildFrom: superLayout scope: aScope host: aClass
	self flag: #todo. "Seems that #extendByte already checks for #hasFields, so next code shouldnt be needed, right?"
	"	aScope hasFields 
		ifTrue: [ self error: 'No fields expected!!' ]."
	^ superLayout extendByte
		host: aClass;
		yourself! !

!ByteLayout methodsFor: 'extending' stamp: 'MartinDias 8/7/2012 00:47'!
extendWord
	PrimitiveTypeConflict new
		layout: self;
		subType: #word;
		signal! !

!ByteLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecification
	^ 8! !

BitsLayout subclass: #WordLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!WordLayout commentStamp: '<historical>' prior: 0!
I am a raw data layout that holds words (32 / 64 bit depending on the platform).!

!WordLayout class methodsFor: 'instance creation' stamp: 'MartinDias 8/1/2012 00:27'!
buildFrom: superLayout scope: aScope host: aClass
	self flag: #todo. "Seems that #extendByte already checks for #hasFields, so next code shouldnt be needed, right?"
"	aScope hasFields 
		ifTrue: [ self error: 'No fields expected!!' ].
"	^ superLayout extendWord
		host: aClass;
		yourself! !

!WordLayout methodsFor: 'extending' stamp: 'MartinDias 8/7/2012 00:47'!
extendByte
	PrimitiveTypeConflict new
		layout: self;
		subType: #byte;
		signal! !

!WordLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecification
	^ 6! !

ObjectLayout subclass: #CompiledMethodLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!CompiledMethodLayout commentStamp: '<historical>' prior: 0!
I am a special layout version for CompiledMethods. 
Unlike default Object layouts, CompiledMethods define a custom format integer since they mix bytes and pointer types.

See CompiledMethod for more details.!

!CompiledMethodLayout class methodsFor: 'instance creation' stamp: 'MartinDias 7/3/2013 17:25'!
buildFrom: superLayout scope: aScope host: aClass
	^ superLayout extendCompiledMethod
		host: aClass;
		yourself! !

!CompiledMethodLayout methodsFor: 'format' stamp: 'MartinDias 7/4/2013 12:52'!
format
	^ 1538 bitOr: (compactClassIndex bitShift: 11)! !

ObjectLayout subclass: #LayoutWithSlots
	instanceVariableNames: 'slotScope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!LayoutWithSlots commentStamp: '<historical>' prior: 0!
I am the superclass for all layouts with Slots.!

!LayoutWithSlots methodsFor: 'comparing' stamp: 'MartinDias 4/12/2013 13:23'!
= other
	^ super = other
		ifFalse: [  false ]
		ifTrue: [ self slotScope = other slotScope ]! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 02:23'!
allSlots
	^ slotScope flatten! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/4/2011 13:30'!
allVisibleSlots
	^ slotScope allVisibleSlots! !

!LayoutWithSlots methodsFor: 'compatibility' stamp: 'CamilloBruni 4/4/2011 13:20'!
atName: aName
	^ slotScope atName: aName! !

!LayoutWithSlots methodsFor: 'compatibility' stamp: 'ToonVerwaest 4/1/2011 14:03'!
atName: aName ifAbsent: aBlock
	^ slotScope atName: aName ifAbsent: aBlock! !

!LayoutWithSlots methodsFor: 'validation' stamp: 'MartinDias 7/8/2013 16:40'!
checkInheritedSlots
	
	self host superclass 
		ifNil: [ ^ self ].
	self host layout
		ifNil: [ ^ self ].
		
	self 
		assert: (self host superclass layout size <= self host layout size)
		description: [ (self host name, ' does not inherit all slots from ', self host superclass name) ].
	
	"check that the we have the same slots at the same indices as in the superclass"
	self host superclass layout allSlots withIndexDo: [ :slot :index|
		| localSlot |
		localSlot := (self host layout slotAt: index).
		self 
			assert: slot = localSlot
			description: [ 'Slot "', localSlot name, '" index at position ', index asString, ' conflicts with slot "', slot name, '" in ', self host superclass asString ]].! !

!LayoutWithSlots methodsFor: 'validation' stamp: 'MartinDias 7/8/2013 17:21'!
checkIntegrity
	self
		checkSanity;
		checkParentScopes;
		checkInheritedSlots! !

!LayoutWithSlots methodsFor: 'validation' stamp: 'MartinDias 7/8/2013 17:21'!
checkParentScopes
	| parentScope superclassScope |
	parentScope := self slotScope parentScope.
	superclassScope := self host superclass layout slotScope.
	self 
		assert: parentScope = superclassScope
		description: 'Parent slot scope is out of sync'! !

!LayoutWithSlots methodsFor: 'validation' stamp: 'MartinDias 7/8/2013 15:52'!
checkSanity
	super checkSanity.
	self 
		checkSlotNames;
		checkSlotIndices! !

!LayoutWithSlots methodsFor: 'validation' stamp: 'ToonVerwaest 4/1/2011 02:43'!
checkSlotIndices
	| slots current |
	slots := slotScope flatten.
	[ slots size > 1 ] whileTrue: [
		current := slots removeFirst.
		self assert: slots first index = (current index + current size) ]! !

!LayoutWithSlots methodsFor: 'validation' stamp: 'ToonVerwaest 4/3/2011 16:01'!
checkSlotNames
	| slots current |
	slots := slotScope allVisibleSlots.
	[ slots isEmpty ] whileFalse: [
		current := slots removeLast.
		slots do: [ :other |
			other name == current name
				ifTrue: [ 
					SlotDuplicationConflict new
						oldSlot: current;
						newSlot: other;
						host: host;
						signal ]]]! !

!LayoutWithSlots methodsFor: 'diff' stamp: 'ToonVerwaest 4/7/2011 11:53'!
computeChangesFrom: other in: modification
	| additions changes removals copies |
	other hasSlots ifFalse: [ ^ modification additions: self allSlots asArray ].
	
	additions := self allSlots.
	removals := OrderedCollection new.
	copies := modification copies.
	changes := modification changes.
	
	other allSlots do: [ :oldSlot |
		(self popSlot: oldSlot from: additions)
			ifNil: [ removals add: oldSlot ]
			ifNotNil: [ :newSlot |
				newSlot = oldSlot
					ifTrue: [ copies at: newSlot put: oldSlot ]
					ifFalse: [ changes at: newSlot put: oldSlot ]]].
			
	modification
		additions: additions asArray;
		removals: removals asArray.! !

!LayoutWithSlots methodsFor: 'extending' stamp: 'CamilloBruni 4/4/2011 15:39'!
extend: aScope
	^ self species new slotScope: aScope! !

!LayoutWithSlots methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/1/2011 03:25'!
extendAgain: aLayout with: someScope
	| result |
	result := aLayout copy.
	result slotScope: someScope.
	^ result! !

!LayoutWithSlots methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:31'!
extendVariable: newScope
	^ VariableLayout new slotScope: newScope! !

!LayoutWithSlots methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:31'!
extendWeak: newScope
	^ WeakLayout new slotScope: newScope! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:28'!
fieldSize
	^ slotScope fieldSize! !

!LayoutWithSlots methodsFor: 'forking' stamp: 'MartinDias 7/30/2012 01:39'!
forkLayout: aLayout
	| forkScope |
	forkScope := slotScope forkScope: aLayout slotScope.
 	^ aLayout species buildFrom: self scope: forkScope host: self host! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:16'!
hasFields
	^ slotScope hasFields! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 02:25'!
hasSlots
	^ slotScope hasSlots! !

!LayoutWithSlots methodsFor: 'comparing' stamp: 'MartinDias 4/12/2013 13:24'!
hash
	^ self class hash bitXor: self slotScope hash! !

!LayoutWithSlots methodsFor: 'compatibility' stamp: 'ToonVerwaest 4/1/2011 15:26'!
includesName: aName
	self atName: aName ifAbsent: [ ^ false ].
	^ true! !

!LayoutWithSlots methodsFor: 'instance initialization' stamp: 'ToonVerwaest 4/1/2011 01:54'!
initializeInstance: anInstance
	self allSlotsDo: [ :slot | slot initialize: anInstance ]! !

!LayoutWithSlots methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:33'!
instanceSpecification
	| base |
	base := self instanceSpecificationBase.
	^ self hasFields
		ifTrue: [ base + 1 ]
		ifFalse: [ base ]! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/4/2011 13:48'!
instanceVariables
	^ slotScope visibleSlotNames! !

!LayoutWithSlots methodsFor: 'diff' stamp: 'ToonVerwaest 4/1/2011 02:45'!
popSlot: aSlot from: collection
	collection withIndexDo: [ :slot :index |
		slot name == aSlot name
			ifTrue: [ ^ collection removeAt: index ]].
	^ nil! !

!LayoutWithSlots methodsFor: 'copying' stamp: 'ToonVerwaest 4/2/2011 21:00'!
postCopy
	slotScope := slotScope copy! !

!LayoutWithSlots methodsFor: 'printing' stamp: 'ToonVerwaest 4/1/2011 01:40'!
printSlotDefinitionOn: aStream
	slotScope printSlotDefinitionOn: aStream! !

!LayoutWithSlots methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/1/2011 17:24'!
reshapeTo: aModification
	| newScope |
	newScope := slotScope rebase: aModification originalScope to: aModification newScope.
	^ aModification newLayout extendAgain: self with: newScope.! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/7/2011 12:10'!
resolveSlot: aName
	^ slotScope atName: aName! !

!LayoutWithSlots methodsFor: 'testing' stamp: 'CamilloBruni 10/16/2011 20:20'!
size 
	^ slotScope fieldSize! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'CamilloBruni 10/16/2011 20:12'!
slotAt: index
	self flag: 'clean..'.
	^ self allSlots at: index! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:13'!
slotScope
	^ slotScope! !

!LayoutWithSlots methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:13'!
slotScope: anObject
	slotScope := anObject! !

LayoutWithSlots subclass: #PointerLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!PointerLayout commentStamp: '<historical>' prior: 0!
I am the default layout for objects.

I contain a fixed number of Slots.
Instances of classes using this kind of layout have always the same size.!

!PointerLayout class methodsFor: 'instance creation' stamp: 'MartinDias 7/30/2012 01:43'!
buildFrom: superLayout scope: aScope host: aClass
	^ (superLayout extend: aScope)
		host: aClass;
		yourself! !

!PointerLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecificationBase
	^ 0! !

LayoutWithSlots subclass: #VariableLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!VariableLayout commentStamp: '<historical>' prior: 0!
I am the default layout for variable sized objects such as Array.

I contain a fixed number of Slots plus.
Instances of classes using this kind of layout have only a minimum given size. Instances have a custom number of additional fields which can be accessed with an index.!

!VariableLayout class methodsFor: 'instance creation' stamp: 'MartinDias 7/30/2012 01:43'!
buildFrom: superLayout scope: aScope host: aClass
	^ (superLayout extendVariable: aScope)
		host: aClass;
		yourself! !

!VariableLayout methodsFor: 'reshaping' stamp: 'ToonVerwaest 4/1/2011 02:55'!
extendAgain: aLayout with: someScope
	| result |
	result := self species new.
	result host: aLayout host.
	aLayout compactClassIndex > 0
		ifTrue: [ result compactClassIndex: aLayout compactClassIndex ].
	result slotScope: someScope.
	^ result! !

!VariableLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecificationBase
	^ 2! !

!VariableLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:26'!
isVariable
	^ true! !

LayoutWithSlots subclass: #WeakLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!WeakLayout commentStamp: '<historical>' prior: 0!
I am a special layout for weak variable sized objects such as WeakArray.

I contain a fixed number of Slots plus.
Instances of classes using this kind of layout have only a minimum given size. Instances have a custom number of additional weak fields which can be accessed with an index.

References held in the variable part are held weakly and might be nilled out by the garbage collector at any time. References in the named section are held strongly as in the default layout.!

!WeakLayout class methodsFor: 'instance creation' stamp: 'MartinDias 7/30/2012 01:44'!
buildFrom: superLayout scope: aScope host: aClass
	^ (superLayout extendWeak: aScope)
		host: aClass;
		yourself! !

!WeakLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 01:27'!
instanceSpecification
	^ 4! !

!WeakLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:26'!
isVariable
	^ true! !

!WeakLayout methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 01:26'!
isWeak
	^ true! !

!ObjectLayout class methodsFor: 'instance creation' stamp: 'MartinDias 7/30/2012 01:40'!
buildFrom: superLayout scope: aScope host: aClass
	self subclassResponsibility! !

!ObjectLayout methodsFor: 'comparing' stamp: 'MartinDias 4/12/2013 13:27'!
= other
	^ super = other
		ifFalse: [ false ]
		ifTrue: [ self compactClassIndex = other compactClassIndex ]! !

!ObjectLayout methodsFor: 'accessing' stamp: 'MartinDias 3/28/2013 12:00'!
compactClassIndex
	^ compactClassIndex! !

!ObjectLayout methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:35'!
compactClassIndex: anIndex
	compactClassIndex := anIndex.
	host setFormat: self format! !

!ObjectLayout methodsFor: 'diff' stamp: 'ToonVerwaest 4/1/2011 02:22'!
computeChangesFrom: other in: modification
	other hasSlots ifTrue: [
		modification removals: other allSlots asArray ]! !

!ObjectLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:25'!
extend: aScope
	PrimitiveTypeConflict new
		layout: self;
		subType: #slot;
		signal! !

!ObjectLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:56'!
extendByte
	self hasFields ifTrue: [
		PrimitiveTypeConflict new
			layout: self;
			subType: #byte;
			signal ].
	^ ByteLayout new! !

!ObjectLayout methodsFor: 'extending' stamp: 'MartinDias 7/3/2013 17:23'!
extendCompiledMethod
	self hasFields ifTrue: [
		PrimitiveTypeConflict new
			layout: self;
			subType: #compiledMethod;
			signal ].
	^ CompiledMethodLayout new! !

!ObjectLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:26'!
extendVariable: aScope
	PrimitiveTypeConflict new
		layout: self;
		subType: #variable;
		signal! !

!ObjectLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/1/2011 13:56'!
extendWord
	self hasFields ifTrue: [
		PrimitiveTypeConflict new
			layout: self;
			subType: #word;
			signal ].
	^ WordLayout new! !

!ObjectLayout methodsFor: 'format' stamp: 'MartinDias 7/3/2013 18:00'!
format
	"Answer an Integer that encodes this layout in the way that VM expects it."
	
	| fieldSize sizeHiBits format |
	fieldSize := self fieldSize + 1.
	sizeHiBits := fieldSize // 64.
	format := sizeHiBits.
	format := (format bitShift: 5) + compactClassIndex.
	format := (format bitShift: 4) + self instanceSpecification.
	format := (format bitShift: 6) + (fieldSize \\ 64).
	format := (format bitShift: 1).
	^ format! !

!ObjectLayout methodsFor: 'comparing' stamp: 'MartinDias 4/12/2013 13:27'!
hash
	^ super hash bitXor: self compactClassIndex! !

!ObjectLayout methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 01:34'!
initialize
	compactClassIndex := 0! !

!ObjectLayout methodsFor: 'initialize-release' stamp: 'ToonVerwaest 4/1/2011 01:53'!
initializeInstance: anInstance
	self subclassResponsibility! !

!ObjectLayout methodsFor: 'reshaping' stamp: 'MartinDias 4/4/2013 20:24'!
reshapeFrom: oldScope to: newLayout
	| newScope |
	newScope := self slotScope rebase: oldScope to: newLayout slotScope.
	^ newLayout extendAgain: self with: newScope.! !

!ObjectLayout methodsFor: 'reshaping' stamp: 'MartinDias 7/30/2012 01:39'!
reshapeTo: aModification
	^ self class buildFrom: aModification layout scope: LayoutEmptyScope instance host: self host! !

ObjectLayout subclass: #SmallIntegerLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!SmallIntegerLayout commentStamp: '<historical>' prior: 0!
I am the special layout for SmallIntegers.

SmallIntegers are typically implemented as tagged pointers and thus require a special format.!

!SmallIntegerLayout methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 17:32'!
extend: newScope
	^ PointerLayout new slotScope: newScope! !

!SmallIntegerLayout methodsFor: 'format' stamp: 'ToonVerwaest 4/1/2011 04:12'!
format
	^ 2! !

!SmallIntegerLayout methodsFor: 'initialize-release' stamp: 'CamilloBruni 10/16/2011 20:21'!
initialize
	super initialize.
	self host: SmallInteger.! !

Object subclass: #AbstractMethodUpdateStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractMethodUpdateStrategy commentStamp: '<historical>' prior: 0!
I am used to update compiled methods in response to class modifications.
My sublcasses implement different strategies to update affected methods.!

!AbstractMethodUpdateStrategy methodsFor: 'updating' stamp: 'MartinDias 7/30/2012 00:08'!
transform: oldClass to: newClass using: aMethodModification

	self subclassResponsibility ! !

AbstractMethodUpdateStrategy subclass: #MethodRecompileStrategy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!MethodRecompileStrategy commentStamp: '<historical>' prior: 0!
I am simple update strategy that recompiles all methods.!

!MethodRecompileStrategy methodsFor: 'updating' stamp: 'MartinDias 5/7/2013 19:10'!
transform: oldClass to: newClass using: aMethodModification
	newClass compileAllFrom: oldClass.
	
	"Somehow something is not fully ready yet when recompiling so we have to manually update the class literal (last literal) to properly use the newClass' name"
	self updateClassLiteralKeysIn: newClass! !

!MethodRecompileStrategy methodsFor: 'updating' stamp: 'MartinDias 5/7/2013 19:09'!
updateClassLiteralKeysIn: aClass 
	aClass isMeta ifTrue: [ ^ self ].
	
	aClass methodsDo: [ :method | | literal |
		literal := method allLiterals last.
		literal value = aClass
			ifTrue: [ literal key: aClass name ]]! !

Object subclass: #AbstractModification
	instanceVariableNames: 'slotShift modificationMap'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!AbstractModification commentStamp: '<historical>' prior: 0!
Modifications to a high-level class have an impact on the related low-level structures. There are two modification models that transform the high-level model into concrete low-level modifications models, the method modification model and the instance modification model. Both models list for every field, whether it was added, removed, or shifted to a new position.

Instance Variables:
	slotShift	<Integer>
	modificationMap	<(Collection of: AbstractFieldModification)>!

!AbstractModification class methodsFor: 'instance creation' stamp: 'ToonVerwaest 3/24/2011 12:17'!
new: anInteger
	^ self new initialize: anInteger ! !

!AbstractModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/28/2011 19:46'!
initialize: anInteger
	self initialize.
	modificationMap := Array new: anInteger.! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:12'!
installAddedSlot: addedSlot
	self subclassResponsibility! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:12'!
installModifiedSlot: modifiedSlot
	self subclassResponsibility! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:12'!
installRemovedSlot: removedSlot
	self subclassResponsibility! !

!AbstractModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:29'!
installUnmodifiedSlot: unmodifiedSlot
	modificationMap
		at: unmodifiedSlot fieldIndex
		put: unmodifiedSlot! !

!AbstractModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/30/2011 13:52'!
modificationAt: idx
	idx > modificationMap size 
		ifTrue: [ ^ slotShift ].
	^ modificationMap at: idx! !

!AbstractModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/24/2011 12:18'!
size
	^ modificationMap size.! !

!AbstractModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/24/2011 11:37'!
slotShift: aShift
	slotShift := aShift! !

AbstractModification subclass: #InstanceModification
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!InstanceModification commentStamp: '<historical>' prior: 0!
I collect and provide the information to migrate instances when a class changed.!

!InstanceModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:13'!
installAddedSlot: addedSlot
	modificationMap at: addedSlot newFieldIndex put: addedSlot! !

!InstanceModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
installModifiedSlot: modifiedSlot
	modificationMap at: modifiedSlot newFieldIndex put: modifiedSlot! !

!InstanceModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:14'!
installRemovedSlot: removedSlot
	" ignore "! !

AbstractModification subclass: #MethodModification
	instanceVariableNames: 'addedSlots'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!MethodModification commentStamp: '<historical>' prior: 0!
I collect and provide the information to update methods when a class changed.!

!MethodModification methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 20:06'!
addedSlotNamed: name ifAbsent: aBlock
	^ addedSlots at: name ifAbsent: aBlock! !

!MethodModification methodsFor: 'initialize-release' stamp: 'ToonVerwaest 3/28/2011 19:47'!
initialize
	addedSlots := Dictionary new! !

!MethodModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 19:48'!
installAddedSlot: addedSlot
	addedSlots at: addedSlot name put: addedSlot! !

!MethodModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:15'!
installModifiedSlot: modifiedSlot
	modificationMap at: modifiedSlot oldFieldIndex put: modifiedSlot! !

!MethodModification methodsFor: 'installing' stamp: 'ToonVerwaest 3/28/2011 17:15'!
installRemovedSlot: removedSlot
	modificationMap at: removedSlot oldFieldIndex put: removedSlot! !

Object subclass: #LayoutAbstractScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!LayoutAbstractScope commentStamp: '<historical>' prior: 0!
Layout scopes reify how classes extend the layout of their superclass.!

!LayoutAbstractScope methodsFor: 'comparing' stamp: 'MartinDias 4/12/2013 13:29'!
= other
	^ self class = other class! !

!LayoutAbstractScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/2/2011 14:27'!
allSlotsDo: aBlock
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:30'!
allSlotsReverseDo: aBlock
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 13:03'!
atName: aName
	^ self atName: aName ifAbsent: [ SlotNotFound signalForName: aName ].! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 14:04'!
atName: aName ifAbsent: aBlock
	self allSlotsDo: [ :slot | 
		slot name == aName ifTrue: [ ^ slot ]].
	^ aBlock value! !

!LayoutAbstractScope methodsFor: 'extending' stamp: 'ToonVerwaest 4/2/2011 14:25'!
extend: someSlots
	^ self extend: someSlots as: LayoutClassScope! !

!LayoutAbstractScope methodsFor: 'extending' stamp: 'CamilloBruni 4/6/2011 14:28'!
extend: someSlots as: type
	| scope fieldIndex currentParentScope nextParentScope |
	scope := type new: someSlots size.
	fieldIndex := self firstFieldIndex.
	currentParentScope := self.
	
	someSlots withIndexDo: [ :slot :slotIndex | |realSlot|
		realSlot := slot asSlot.
		nextParentScope := realSlot parentScopeFor: currentParentScope.
		nextParentScope == currentParentScope
			ifFalse: [
				currentParentScope := nextParentScope.
				fieldIndex := fieldIndex + currentParentScope ownFieldSize].
		realSlot index: fieldIndex.
		fieldIndex := fieldIndex + realSlot size.
		scope at: slotIndex put: realSlot ].
	
	scope parentScope: currentParentScope.
	^ scope! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:27'!
fieldSize
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 18:33'!
firstFieldIndex
	^ self fieldSize + 1! !

!LayoutAbstractScope methodsFor: 'flattening' stamp: 'ToonVerwaest 4/2/2011 14:28'!
flatten
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:29'!
hasFields
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:29'!
hasSlots
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'comparing' stamp: 'MartinDias 4/12/2013 13:29'!
hash
	^ self class hash! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:25'!
ownFieldSize
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'printing' stamp: 'ToonVerwaest 4/2/2011 14:29'!
printSlotDefinitionOn: aStream
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'reshaping' stamp: 'MartinDias 4/4/2013 20:40'!
rebase: originalScope to: newScope
	self error: 'Should not happen'! !

!LayoutAbstractScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:50'!
visibleSlotNames
	self subclassResponsibility! !

!LayoutAbstractScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 18:31'!
withParentScopesDo: aBlock
	self subclassResponsibility! !

LayoutAbstractScope variableSubclass: #LayoutClassScope
	instanceVariableNames: 'parentScope'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!LayoutClassScope commentStamp: '<historical>' prior: 0!
I am layout scope for classes.!

!LayoutClassScope methodsFor: 'comparing' stamp: 'MartinDias 4/12/2013 13:31'!
= other
	super = other
		ifFalse: [ ^ false ].
	
	self size = other size
		ifFalse: [ ^ false ].
	
	1 to: self size do:  [ :index|
		(self at: index) = (other at: index)
			ifFalse: [ ^ false ]].
	
	^ self parentScope = other parentScope.! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/1/2011 02:11'!
allSlotsDo: aBlock
	parentScope allSlotsDo: aBlock.
	self do: aBlock! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:30'!
allSlotsReverseDo: aBlock
	self reverseDo: aBlock.
	parentScope allSlotsReverseDo: aBlock.! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 12:48'!
allVisibleSlots
	| result |
	result := parentScope allVisibleSlots.
	self do: [ :slot | 
		slot isVisible 
			ifTrue: [ result add: slot ]].
	^ result! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/1/2011 02:10'!
do: aBlock
	1 to: self size do: [ :index |
		aBlock value: (self at: index) ]! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:25'!
fieldSize
	^ parentScope fieldSize + self ownFieldSize.! !

!LayoutClassScope methodsFor: 'flattening' stamp: 'ToonVerwaest 4/1/2011 01:56'!
flatten
	| result |
	result := parentScope flatten.
	result addAll: self.
	^ result! !

!LayoutClassScope methodsFor: 'testing' stamp: 'CamilloBruni 4/4/2011 12:48'!
hasFields
	self do: [ :slot | 
		slot size > 0 
			ifTrue: [ ^ true ]].
	^ parentScope hasFields! !

!LayoutClassScope methodsFor: 'testing' stamp: 'CamilloBruni 4/4/2011 12:48'!
hasSlots
	self size > 0 
		ifTrue: [ ^ true ].
	^ parentScope hasSlots! !

!LayoutClassScope methodsFor: 'comparing' stamp: 'MartinDias 4/12/2013 13:34'!
hash
	| hash |
	hash := super hash.
	1 to: self size do: [ :i | 
		hash := (hash + (self at: i) hash) hashMultiply].
	^ hash bitXor: self parentScope hash.! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:26'!
ownFieldSize
	|result|
	result := 0.
	self do: [ :slot | result := result + slot size ].
	^ result! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'MartinDias 4/12/2013 13:48'!
parentScope
	^ parentScope! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'MartinDias 4/12/2013 13:35'!
parentScope: aLayoutScope
	parentScope := aLayoutScope! !

!LayoutClassScope methodsFor: 'copying' stamp: 'ToonVerwaest 4/2/2011 18:26'!
postCopy
	parentScope := parentScope copy.
	1 to: self size do: [ :index | 
		self at: index put: (self at: index) copy ]! !

!LayoutClassScope methodsFor: 'printing' stamp: 'CamilloBruni 4/4/2011 12:48'!
printSlotDefinitionOn: aStream
	| printedAtLeastOnSlot |
	
	aStream << '{'.
	
	printedAtLeastOnSlot := false.
	
	self do: [ :slot |
		slot isVisible
			ifTrue: [
				aStream lf; tab; tab; store: slot; << '.'.
				printedAtLeastOnSlot := true.]].
			
	printedAtLeastOnSlot 
		ifTrue: [ aStream lf; tab ].
	
	aStream << '}'.! !

!LayoutClassScope methodsFor: 'reshaping' stamp: 'MartinDias 4/4/2013 20:39'!
rebase: originalScope to: newScope
	| newParent result fieldIndex |
	newParent := parentScope == originalScope
		ifTrue: [ newScope ]
		ifFalse: [ parentScope rebase: originalScope to: newScope ].
		
	result := self copy.
	result parentScope: newParent.
	
	fieldIndex := newParent firstFieldIndex.
	result do: [ :slot | 
		slot index: fieldIndex.
		fieldIndex := fieldIndex + slot size ].
	
	^ result
	! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:49'!
reverseDo: aBlock
	|size|
	size := self size.
	1 to: size do: [ :index |
		aBlock value: (self at: (1 + size - index)) ]! !

!LayoutClassScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 12:48'!
visibleSlotNames
	| result |
	result := OrderedCollection new.
	self do: [ :slot | 
		slot isVisible 
			ifTrue: [ result add: slot name ]].
	^ result asArray! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'CamilloBruni 10/16/2011 20:08'!
withIndexDo: elementAndIndexBlock 
	"Just like with:do: except that the iteration index supplies the second argument to the block."
	1 to: self size do:
		[:index |
		elementAndIndexBlock
			value: (self at: index)
			value: index]! !

!LayoutClassScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 18:31'!
withParentScopesDo: aBlock
	aBlock value: self.
	parentScope withParentScopesDo: aBlock.! !

LayoutAbstractScope subclass: #LayoutEmptyScope
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

LayoutEmptyScope class
	instanceVariableNames: 'instance'!

!LayoutEmptyScope commentStamp: '<historical>' prior: 0!
I am the last layout scope in a scope chain.!

LayoutEmptyScope class
	instanceVariableNames: 'instance'!

!LayoutEmptyScope class methodsFor: 'accessing' stamp: 'ToonVerwaest 4/1/2011 01:31'!
instance
	^ instance ifNil: [ instance := self new ]! !

!LayoutEmptyScope methodsFor: 'enumerating' stamp: 'ToonVerwaest 4/2/2011 14:32'!
allSlotsDo: aBlock! !

!LayoutEmptyScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 14:30'!
allSlotsReverseDo: aBlock! !

!LayoutEmptyScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 19:08'!
allVisibleSlots
	^ OrderedCollection new! !

!LayoutEmptyScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 14:31'!
fieldSize
	^ 0! !

!LayoutEmptyScope methodsFor: 'flattening' stamp: 'ToonVerwaest 4/2/2011 14:32'!
flatten
	^ OrderedCollection new! !

!LayoutEmptyScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:33'!
hasFields
	^ false! !

!LayoutEmptyScope methodsFor: 'testing' stamp: 'ToonVerwaest 4/2/2011 14:33'!
hasSlots
	^ false! !

!LayoutEmptyScope methodsFor: 'accessing' stamp: 'CamilloBruni 4/6/2011 14:26'!
ownFieldSize
	^ 0! !

!LayoutEmptyScope methodsFor: 'printing' stamp: 'ToonVerwaest 4/2/2011 14:33'!
printSlotDefinitionOn: aStream
	aStream << '{}'! !

!LayoutEmptyScope methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 19:11'!
visibleSlotNames
	^ {}! !

!LayoutEmptyScope methodsFor: 'enumerating' stamp: 'CamilloBruni 4/4/2011 18:31'!
withParentScopesDo: aBlock
	aBlock value: self.! !

Object subclass: #OldClassBuilderAdapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Transformation'!

!OldClassBuilderAdapter commentStamp: '<historical>' prior: 0!
I am an adapter of a Slot class builder to the traditional class building protocol.!

!OldClassBuilderAdapter methodsFor: 'accessing' stamp: 'MartinDias 7/1/2013 18:36'!
anonymousClassInstaller
	^ AnonymousClassInstaller! !

!OldClassBuilderAdapter methodsFor: 'adapted api' stamp: 'MartinDias 7/1/2013 18:36'!
anonymousSubclassOf: superClass
	"Answer an anonymous subclass of the given superclass."

	^ self anonymousClassInstaller make: [ :builder |
		builder
			superclass: superClass;
			layoutClass: superClass layout class ].
! !

!OldClassBuilderAdapter methodsFor: 'adapted api' stamp: 'CamilloBruni 6/28/2013 14:47'!
class: oldClass instanceVariableNames: instVarString
	"This is the basic initialization message to change the definition of an existing Metaclass"

	| theClass |
	theClass := oldClass theNonMetaClass.
	
	theClass := self slotClassInstaller make: [ :builder |
		builder
			superclass: theClass superclass;
			name: theClass name;
			layoutClass: theClass layout class;
			slots: (theClass instVarNames collect: [:n | n asSlot ]);
			sharedVariables: theClass classVariablesString;
			sharedPools: theClass sharedPoolsString;
			traitComposition: theClass traitComposition;
			category: theClass category asString;
			classSlots: instVarString asSlotCollection ].
	^ theClass theMetaClass! !

!OldClassBuilderAdapter methodsFor: 'accessing' stamp: 'CamilloBruni 6/28/2013 13:56'!
layoutForType: typeSymbol
	typeSymbol = #compiledMethod 
		ifTrue: [ ^ CompiledMethodLayout ].
	typeSymbol = #bytes 
		ifTrue: [ ^ ByteLayout ].
	typeSymbol = #words 
		ifTrue: [ ^ WordLayout ].
	typeSymbol = #weak 
		ifTrue: [ ^ WeakLayout ].
	typeSymbol = #variable 
		ifTrue: [ ^ VariableLayout ].
	typeSymbol = #normal 
		ifTrue: [ ^ PointerLayout ].
	Error signal: 'Invalid layout type: ', typeSymbol asString.! !

!OldClassBuilderAdapter methodsFor: 'adapted api' stamp: 'MartinDias 7/1/2013 16:03'!
name: name inEnvironment: environment subclassOf: superClass type: type instanceVariableNames: instanceVariablesString classVariableNames: classVariablesString poolDictionaries: sharedPoolsString category: category
	"Define a new class in the given environment"
	^ self slotClassInstaller make: [ :builder |
		builder
			superclass: superClass;
			name: name;
			layoutClass: (self layoutForType: type);
			slots: instanceVariablesString asSlotCollection;
			sharedVariables: classVariablesString;
			sharedPools: sharedPoolsString;
			category: category;
			environment: environment;
			copyTraitCompositionFromExistingClass ].
! !

!OldClassBuilderAdapter methodsFor: 'accessing' stamp: 'MartinDias 6/14/2013 17:42'!
slotClassInstaller
	^ PharoClassInstaller! !

!OldClassBuilderAdapter methodsFor: 'adapted api' stamp: 'MartinDias 6/14/2013 18:11'!
superclass: newSuper
	subclass: t instanceVariableNames: f 
	classVariableNames: d poolDictionaries: s category: cat 
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class."
	^self 
		name: t
		inEnvironment: newSuper environment
		subclassOf: newSuper
		type: newSuper typeOfClass
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!OldClassBuilderAdapter methodsFor: 'adapted api' stamp: 'MartinDias 6/14/2013 18:01'!
superclass: aClass
	variableByteSubclass: t instanceVariableNames: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class in which the subclass is to 
	have indexable byte-sized nonpointer variables."
	| oldClassOrNil actualType |
	(aClass instSize > 0)
		ifTrue: [^self error: 'cannot make a byte subclass of a class with named fields'].
	(aClass isVariable and: [aClass isWords])
		ifTrue: [^self error: 'cannot make a byte subclass of a class with word fields'].
	(aClass isVariable and: [aClass isPointers])
		ifTrue: [^self error: 'cannot make a byte subclass of a class with pointer fields'].
	oldClassOrNil := aClass environment at: t ifAbsent:[nil].
	actualType := (oldClassOrNil notNil
				   and: [oldClassOrNil typeOfClass == #compiledMethod])
					ifTrue: [#compiledMethod]
					ifFalse: [#bytes].
	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: actualType
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!OldClassBuilderAdapter methodsFor: 'adapted api' stamp: 'MartinDias 6/14/2013 18:00'!
superclass: aClass
	variableSubclass: t instanceVariableNames: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class in which the subclass is to 
	have indexable pointer variables."
	aClass isBits 
		ifTrue: [^self error: 'cannot make a pointer subclass of a class with non-pointer fields'].
	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: #variable
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!OldClassBuilderAdapter methodsFor: 'adapted api' stamp: 'MartinDias 6/14/2013 17:59'!
superclass: aClass
	variableWordSubclass: t instanceVariableNames: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class in which the subclass is to 
	have indexable word-sized nonpointer variables."
	(aClass instSize > 0)
		ifTrue: [^self error: 'cannot make a word subclass of a class with named fields'].
	(aClass isVariable and: [aClass isBytes])
		ifTrue: [^self error: 'cannot make a word subclass of a class with byte fields'].
	(aClass isVariable and: [aClass isPointers])
		ifTrue: [^self error: 'cannot make a word subclass of a class with pointer fields'].

	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: #words
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

!OldClassBuilderAdapter methodsFor: 'adapted api' stamp: 'MartinDias 6/14/2013 17:58'!
superclass: aClass
	weakSubclass: t instanceVariableNames: f 
	classVariableNames: d poolDictionaries: s category: cat
	"This is the standard initialization message for creating a new class as a 
	subclass of an existing class (the receiver) in which the subclass is to 
	have weak indexable pointer variables."
	aClass isBits 
		ifTrue: [^self error: 'cannot make a pointer subclass of a class with non-pointer fields'].
	^self 
		name: t
		inEnvironment: aClass environment
		subclassOf: aClass
		type: #weak
		instanceVariableNames: f
		classVariableNames: d
		poolDictionaries: s
		category: cat! !

Object subclass: #Slot
	instanceVariableNames: 'index name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Layout'!

!Slot commentStamp: '<historical>' prior: 0!
I'm a meta-object for accessing a field in an Object.
By default each Slot corresponds to an instance variable and vice versa. Hence there is a Slot for each instance variable.

I define a protocol to read (#read:) and to write (#write:to:) values to a field inside an Object.

For customizing a subclass can override the meta-obejct-protocol methods. See subclasses for examples.

Vocabulary:
- variable: named accessor for a Slot
- Slot: class-side meta-object, mapping of names to values using a MOP to fields
- field: space occupied in an object, used to hold values accessed via Slots!

!Slot class methodsFor: 'instance creation' stamp: 'CamilloBruni 3/22/2011 16:40'!
asSlot
	^ self new! !

!Slot class methodsFor: 'validating' stamp: 'MartinDias 8/7/2012 01:31'!
checkValidName: aSymbol
	aSymbol isPseudovariableName ifTrue: [ 
		^ InvalidSlotNameConflict signal: aSymbol, ' is an invalid name for a slot' ]! !

!Slot class methodsFor: 'instance creation' stamp: 'MartinDias 8/7/2012 01:12'!
named: aSymbol
	self checkValidName: aSymbol.
	^ self new
		name: aSymbol;
		yourself! !

!Slot methodsFor: 'comparing' stamp: 'MartinDias 6/24/2013 18:11'!
= other
	self == other
		ifTrue: [ ^ true ].
	^ ((self species == other species) 
			and: [ index = other index ])
			and: [ name = other name ]! !

!Slot methodsFor: 'converting' stamp: 'CAmi 3/15/2011 14:34'!
asSlot
	^ self! !

!Slot methodsFor: 'finalization' stamp: 'CAmi 3/15/2011 16:55'!
finalize: layout
	"nothing to do here"! !

!Slot methodsFor: 'comparing' stamp: 'MartinDias 4/12/2013 13:37'!
hash
	^ (self species hash bitXor: self name hash) bitXor: self index! !

!Slot methodsFor: 'accessing' stamp: 'CamilloBruni 3/10/2011 15:01'!
index
	^ index! !

!Slot methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 18:16'!
index: anIndex
	index := anIndex! !

!Slot methodsFor: 'initialization' stamp: 'CamilloBruni 3/10/2011 17:17'!
initialize: instance
	"nothing to do for the default slot"! !

!Slot methodsFor: 'private' stamp: 'MartinDias 6/24/2013 16:29'!
internalRead: anObject
	^ anObject instVarAt: index! !

!Slot methodsFor: 'private' stamp: 'MartinDias 6/24/2013 16:29'!
internalWrite: aValue to: anObject
	anObject instVarAt: index put: aValue.! !

!Slot methodsFor: 'testing' stamp: 'CamilloBruni 3/30/2011 18:46'!
isVisible
	^ true! !

!Slot methodsFor: 'testing' stamp: 'CamilloBruni 3/10/2011 15:01'!
name
	^ name! !

!Slot methodsFor: 'accessing' stamp: 'MartinDias 7/29/2012 20:58'!
name: aSymbol
	name := aSymbol! !

!Slot methodsFor: 'accessing' stamp: 'CamilloBruni 4/4/2011 18:41'!
parentScopeFor: aScope
	^ aScope! !

!Slot methodsFor: 'printing' stamp: 'CamilloBruni 3/30/2011 15:37'!
printOn: aStream
	aStream << self name << ' => '; << self class name.! !

!Slot methodsFor: 'meta-object-protocol' stamp: 'MartinDias 6/24/2013 16:28'!
read: anObject
	^ self internalRead: anObject! !

!Slot methodsFor: 'accessing' stamp: 'CAmi 3/15/2011 14:32'!
size
	^ 1! !

!Slot methodsFor: 'printing' stamp: 'CAmi 3/15/2011 17:59'!
storeInitializationOn: aStream
	aStream nextPutAll: self class name! !

!Slot methodsFor: 'printing' stamp: 'CamilloBruni 3/29/2011 16:36'!
storeOn: aStream
	aStream store: self name.
	aStream nextPutAll: ' => '.
	self storeInitializationOn: aStream.! !

!Slot methodsFor: 'meta-object-protocol' stamp: 'MartinDias 6/24/2013 16:29'!
write: aValue to: anObject
	self internalWrite: aValue to: anObject! !

Object subclass: #SlotClassBuilder
	instanceVariableNames: 'client oldClasses newClasses classSlots category superclass name layoutClass slots traitComposition classTraitComposition result sharedPoolsString sharedVariablesString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-ClassBuilder'!

!SlotClassBuilder commentStamp: '<historical>' prior: 0!
I'm responsible for building and verifying new classes. 
The update and modification/installation of classes are managed by installers (AbstractClassInstallation).

The class builder is responsible for the structural part of modifying a class or creating a new class. It relies on the installer to fetch the old version of the class. It then uses the class modification model to compute the method modification and instance modification models. It then validates if these changes are semantically sound.

Example:
	see PharoClassInstaller!

!SlotClassBuilder methodsFor: 'private' stamp: 'MartinDias 7/8/2013 17:03'!
apply: classModification
	classModification modifiesSlots
		ifTrue: [self applySlotChange: classModification]
		ifFalse: [ 
			classModification modifiesFormat
				ifTrue: [ self applyFormatChange: classModification]
				ifFalse: [
					classModification modifiesSuperclass
						ifTrue: [ self applySuperclassChange: classModification ]
						ifFalse: [ ^ self installTraitComposition: classModification ]]].
	
	self 
		migrateClasses: classModification;
		cleanUp! !

!SlotClassBuilder methodsFor: 'private' stamp: 'MartinDias 7/1/2013 15:49'!
applyAndUpdateFormat: classModification
	^ self track: classModification during: [ :old :new |
		client formatChangedFrom: old to: new by: classModification ].! !

!SlotClassBuilder methodsFor: 'private' stamp: 'MartinDias 7/1/2013 15:51'!
applyAndUpdateSlots: classModification
	^ self track: classModification during: [ :old :new |
		client slotsChangedFrom: old to: new by: classModification ].! !

!SlotClassBuilder methodsFor: 'private' stamp: 'MartinDias 7/1/2013 15:48'!
applyAndUpdateSuperclass: classModification
	^ self track: classModification during: [ :old :new |
		client superclassChangedFrom: old to: new by: classModification ]! !

!SlotClassBuilder methodsFor: 'private' stamp: 'ToonVerwaest 4/1/2011 03:18'!
applyFormatChange: classModification
	result := self applyAndUpdateFormat: classModification.
	classModification propagationsDo: [ :propagation | 
		self applyAndUpdateFormat: propagation ]! !

!SlotClassBuilder methodsFor: 'private' stamp: 'MartinDias 7/1/2013 15:45'!
applySlotChange: classModification
	result := self applyAndUpdateSlots: classModification.
	classModification propagationsDo: [ :propagation | 
		self applyAndUpdateSlots: propagation ]! !

!SlotClassBuilder methodsFor: 'private' stamp: 'MartinDias 7/1/2013 15:45'!
applySuperclassChange: classModification
	result := self applyAndUpdateSuperclass: classModification.
	classModification propagationsDo: [ :propagation | 
		self applyAndUpdateSuperclass: propagation ]! !

!SlotClassBuilder methodsFor: 'initialize-release' stamp: 'MartinDias 7/1/2013 16:02'!
build
	| oldClass metaChange classChange |
	result := oldClass := client classAt: name ifAbsent: [ ^ self buildNewClass ].

	self validateSuperChain: oldClass.
	
	metaChange := ClassModification
							modify: oldClass class
							extend: self superMetaclass
							withLayoutType: PointerLayout
							slots: classSlots
							traitComposition: classTraitComposition.
	
	classChange := ClassModification
							modify: oldClass
							extend: superclass
							withLayoutType: layoutClass
							slots: slots
							traitComposition: traitComposition.
	
	self apply: metaChange.
	self apply: classChange.

	result instanceSide 
		declare: sharedVariablesString;
		sharing: sharedPoolsString.

	result isMeta ifFalse: [
		client recategorize: result to: category ].
	
	^ result instanceSide! !

!SlotClassBuilder methodsFor: 'initialize-release' stamp: 'MartinDias 7/1/2013 16:02'!
buildNewClass
	| metaclass newClass |
	metaclass := Metaclass new.
	metaclass
		superclass: self superMetaclass
		withLayoutType: PointerLayout
		slots: classSlots.

	newClass := metaclass new.
	newClass setName: name.
	
	newClass
		superclass: superclass
		withLayoutType: layoutClass
		slots: slots.

	newClass declare: sharedVariablesString.
	newClass sharing: sharedPoolsString.
	
	client installTraitComposition: traitComposition on: newClass.
	client installTraitComposition: classTraitComposition on: metaclass.
	
	client classAdded: newClass inCategory: category.
	
	^ newClass! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
category: aCategory
	category := aCategory! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
classSlots: someClassSlots
	classSlots := someClassSlots! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 4/2/2011 20:53'!
classTraitComposition: aTraitComposition
	classTraitComposition := aTraitComposition asTraitComposition! !

!SlotClassBuilder methodsFor: 'private' stamp: 'MartinDias 7/1/2013 15:20'!
cleanUp
	
	oldClasses removeAll.
	newClasses removeAll.! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:28'!
client: aClient
	client := aClient! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'MartinDias 7/1/2013 16:03'!
copyTraitCompositionFromExistingClass
	"Ugly Helper method: I copy over the trait compisition of the class in my builder environment."
	| oldClass |
	oldClass := self environment at: name ifAbsent: [ ^ self ].
	oldClass hasTraitComposition
		ifTrue: [ self traitComposition: oldClass traitComposition copyTraitExpression ].
	oldClass class hasTraitComposition
		ifTrue: [ self classTraitComposition: oldClass class traitComposition copyTraitExpression ]! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'CamilloBruni 5/31/2013 13:05'!
environment
	^ client environment! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'CamilloBruni 6/4/2013 10:06'!
environment: globals
	client environment: globals! !

!SlotClassBuilder methodsFor: 'initialize-release' stamp: 'MartinDias 6/24/2013 18:25'!
initialize
	super initialize.
	oldClasses := OrderedCollection new.
	newClasses := OrderedCollection new.
	sharedPoolsString := ''.
	sharedVariablesString := ''.
	classSlots := {}.
	slots := {}.
	layoutClass := PointerLayout.
	superclass := Object.
	classTraitComposition := {} asTraitComposition.
	traitComposition := {} asTraitComposition.! !

!SlotClassBuilder methodsFor: 'private' stamp: 'CamilloBruni 6/28/2013 15:34'!
installTraitComposition: classModification
	client
		installTraitComposition: classModification traitComposition
		on: classModification target.
	! !

!SlotClassBuilder methodsFor: 'private' stamp: 'MartinDias 8/6/2012 11:24'!
invalidGlobalNameError: description
	"Throw a name validation exception"
	
	^ InvalidGlobalNameConflict new signal: description! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
layoutClass: aLayoutClass
	layoutClass := aLayoutClass! !

!SlotClassBuilder methodsFor: 'private' stamp: 'MartinDias 7/1/2013 15:20'!
migrateClasses: classModification.
	
	client
		migrateClasses: oldClasses asArray
		to: newClasses asArray
		using: classModification instanceModification.! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'MartinDias 7/1/2013 16:09'!
name: aName
	[ name := aName asSymbol ]
		on: Error do: [ :error|
			self invalidGlobalNameError: aName ].
	self validateClassName.! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'MartinDias 8/7/2012 02:12'!
sharedPools: poolString 
	sharedPoolsString := poolString! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'MartinDias 8/7/2012 02:29'!
sharedVariables: aString 
	sharedVariablesString := aString ! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/28/2011 00:29'!
slots: someSlots
	slots := someSlots! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'MartinDias 7/1/2013 16:02'!
superMetaclass
	 ^ superclass ifNil: [ Class ] ifNotNil: [ superclass class ].! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'CamilloBruni 5/31/2013 13:04'!
superclass: aSuperclass
	superclass := aSuperclass.
	superclass ifNotNil: [ self validateClass: superclass ].! !

!SlotClassBuilder methodsFor: 'private' stamp: 'MartinDias 7/1/2013 15:27'!
track: classModification during: aBlock
	| old new |
	old := classModification target.
	new := classModification apply.

	aBlock value: old value: new.
	
	" Store the modification for updateClasses "
	oldClasses add: old.
	newClasses add: new.
	^ new! !

!SlotClassBuilder methodsFor: 'accessing' stamp: 'ToonVerwaest 3/31/2011 20:09'!
traitComposition: aTraitComposition
	traitComposition := aTraitComposition asTraitComposition! !

!SlotClassBuilder methodsFor: 'private validating' stamp: 'ToonVerwaest 3/28/2011 00:29'!
validateClass: aClass
	aClass isBehavior
		ifFalse: [ self error: 'Trying to build classes from non-class objects' ].
	aClass isMeta
		ifTrue: [ self error: 'Metaclasses cannot be used for building classes' ].! !

!SlotClassBuilder methodsFor: 'private validating' stamp: 'MartinDias 10/25/2012 01:54'!
validateClassName
	"Validate the new class name. Raise an error if invalid."
	
	name isSymbol ifFalse: [
		self invalidGlobalNameError: 'Class name should be a symbol.' ].

	(name detect: [ :c | (c isAlphaNumeric or: [ c = $_ ]) not ] ifNone: [])
		ifNotNil: [ :c | self invalidGlobalNameError: 'Invalid character: ''', c printString, '''' ].

	name first canBeGlobalVarInitial ifFalse: [
		self invalidGlobalNameError: 'Class name does not start with a valid Global Var Initial.' ].
! !

!SlotClassBuilder methodsFor: 'private validating' stamp: 'MartinDias 8/6/2012 11:23'!
validateSuperChain: oldClass
	superclass ifNil: [ ^ nil ].
	superclass withAllSuperclassesDo: [ :class |
		class == oldClass
			ifTrue: [ CircularHierarchyConflict signal: 'Trying to build a circular hierarchy' ]].! !

Object subclass: #SlotVirus
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Slot-Transformation'!

!SlotVirus commentStamp: 'CAmi 3/15/2011 15:47' prior: 0!
I am used to spread slot into an unaffected system. 

   SlotVirus spread.

Initializes default slots and layouts on all objects (note: so far this will break custom objects with custom slots)!

!SlotVirus class methodsFor: 'installing' stamp: 'MartinDias 7/3/2013 19:09'!
basicLayoutFor: aClass

	aClass typeOfClass = #compiledMethod
		ifTrue: [ ^ aClass superclass layout extendCompiledMethod ].

	aClass isBits
		ifTrue: [
			aClass isBytes 
				ifTrue: [ ^ aClass superclass layout extendByte ]
				ifFalse: [ ^ aClass superclass layout extendWord ] ].
	
	aClass isWeak 
		ifTrue: [ ^ self basicWeakLayoutFor: aClass  ].
	
	aClass isVariable 
		ifTrue: [ ^ self basicVariableLayoutFor: aClass ].
	
	^ aClass superclass layout extend: (self layoutScopeFor: aClass).! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:18'!
basicLayoutScopeFor: aClass
	^ aClass superclass layout slotScope extend: (aClass instVarNames ifNil: [ #() ])! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:18'!
basicVariableLayoutFor: aClass
	^ aClass superclass layout extendVariable: (self layoutScopeFor: aClass)! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:18'!
basicWeakLayoutFor: aClass
	^ aClass superclass layout extendWeak: (self layoutScopeFor: aClass)! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 3/31/2011 13:28'!
checkAllLayouts
	(SystemNavigation default allClasses sort: [:a :b| a name <= b name])
		do: [ :cls|
			self checkLayoutOfClass: cls.
			self checkLayoutOfClass: cls class.]! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 3/31/2011 13:22'!
checkDuplicateClass: cls
	cls isMeta 
		ifTrue: [ ^ self ].
	(Smalltalk includesKey: cls name)
		ifFalse: [ ^ self].
	((Smalltalk at: cls name) == cls)
		ifFalse: [ cls becomeForward: (Smalltalk at: cls name)].! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 10/16/2011 20:12'!
checkInheritedSlots: cls
	| mySlot |
	cls superclass 
		ifNil: [ ^ self ].
		
	(cls superclass layout size <= cls layout size)
		ifFalse: [
			self error: (cls name, ' does not inherit all slots from ', cls superclass name).
			^ self].
	
	cls superclass layout allSlots withIndexDo: [ :slot :index|
		mySlot := (cls layout slotAt: index).
		self haltIf: slot index ~= mySlot index.
		self haltIf: slot name ~= mySlot name].! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 3/31/2011 13:11'!
checkLayout: aClass 
	(aClass withAllSubclasses sort: [:a :b| a name <= b name])
		do: [ :cls|
			self checkLayoutOfClass: cls.
			self checkLayoutOfClass: cls class.]! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 3/31/2011 15:02'!
checkLayoutOfClass: cls
	self checkDuplicateClass: cls.
	self assert: cls layout isNil not.
	"self assert: cls format == cls layout format."
	cls layout checkSanity.
	cls layout hasSlots 
		ifFalse: [ ^ self].
		
	cls isMeta
		ifFalse: [ 
			(cls superclass subclasses includes: cls)
				ifFalse: [
					"self error: (cls name, ' is not properly registered as sublclass of ', cls superclass name)."
					self fixSuperclassSubclasses: cls]].
		
	self checkInheritedSlots: cls.
	
	self checkSlotsIndices: cls! !

!SlotVirus class methodsFor: 'testing' stamp: 'CamilloBruni 10/16/2011 20:14'!
checkSlotsIndices: cls
	cls layout allSlots withIndexDo: [ :slot :index|
		self assert: slot name isNil not.
		self flag: 'fix slot indexing..'
		"self assert: slot index = ((cls layout fixedSizeUpToIndex: index) + 1).
		slot index: ((cls layout fixedSizeUpToIndex: index) + 1)"]! !

!SlotVirus class methodsFor: 'fixing' stamp: 'CamilloBruni 3/31/2011 14:16'!
fixSuperclassSubclasses: cls
	|collection newSubclasses|
	cls superclass 
		ifNil: [ ^ self ].
	cls superclass addSubclass: cls.
	! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:31'!
installLayoutVariable
	(ClassDescription allInstVarNames includes: #layout) ifTrue: [ ^ self ].
	ClassDescription addInstVarNamed: #layout.! !

!SlotVirus class methodsFor: 'installing' stamp: 'MartinDias 7/3/2013 18:53'!
installNewLayouts
	ProtoObject
		instVarNamed: #layout
		put: ((EmptyLayout instance extend: #()) host: ProtoObject).
		
"	self flag: 'I do not like PseudoContext'.
	PseudoContext
		instVarNamed: #layout
		put: ((NilLayout instance extend: #()) host: ProtoObject)."

	ProtoObject allSubclassesDo: [ :aSubclass |
		aSubclass
			instVarNamed: #layout
			put: (self newLayoutFor: aSubclass) ].
		
	SmallInteger
		instVarNamed: #layout
		put: (SmallIntegerLayout new).
		
	CompiledMethod
		instVarNamed: #layout
		put: (self newLayoutFor: CompiledMethod).! !

!SlotVirus class methodsFor: 'testing' stamp: 'ToonVerwaest 4/1/2011 15:26'!
invalidClasses
	| result |
	result := OrderedCollection new.
	ProtoObject withAllSubclassesDo: [ :aClass |
		aClass format ~~ aClass layout format ifTrue: [ result add: aClass ]].
	^ result! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:42'!
layoutScopeFor: aClass
	^ self basicLayoutScopeFor: aClass! !

!SlotVirus class methodsFor: 'installing' stamp: 'CamilloBruni 10/17/2011 16:56'!
newLayoutFor: aClass

	|aLayout|
	
	aLayout := (self basicLayoutFor: aClass).
	aLayout := aClass traitComposition composeWithLayout: aLayout.
		
	"fill in the instvars without triggering any slots"
	^ aLayout
		instVarNamed: #host put: aClass;
		instVarNamed: #compactClassIndex put: aClass indexIfCompact;
		yourself! !

!SlotVirus class methodsFor: 'fixing' stamp: 'MartinDias 8/12/2012 18:21'!
refresh
	#(Slot AbstractLayout SlotObject SlotTest SlotModifier) do: [ :aName |
		Smalltalk 
			at: aName 
			ifPresent: [ :aClass | aClass recompileAll ] ].
	 ! !

!SlotVirus class methodsFor: 'fixing' stamp: 'CamilloBruni 3/28/2011 18:07'!
removeBrokenDoIts
	SystemNavigation default allClassesDo: [ :cls|
		cls methodDict removeKey: #DoItIn: ifAbsent: []].! !

!SlotVirus class methodsFor: 'installing' stamp: 'MartinDias 7/29/2012 20:44'!
spread
	self installLayoutVariable.
	self installNewLayouts.
	
	SystemNavigation default allClasses 
		do: [ :cls|
			cls initializeLayout.
			cls class initializeLayout]
		displayingProgress:[:aClass| 'Processing ', aClass name].
	
	AbstractLayout withAllSubclassesDo: [ :s |
		s allInstances do: [ :aLayout |
			self flag: #todo. "Remove the next if moving initialization code to AbstractLayout class."
			aLayout host ifNotNilDo: [ :host |
				aLayout instVarNamed: #compactClassIndex put: host indexIfCompact ] ]].! !

!ClassDescription methodsFor: '*Slot' stamp: 'CamilloBruni 10/18/2011 15:10'!
initializeLayout
	(self allInstVarNames includes: #layout) 
		ifFalse: [ ^ self ].
		
	layout isNil ifFalse: [ ^ self ].
	
	self superclass isNil 
		ifFalse: [ self superclass initializeLayout ].
	
	layout := SlotVirus newLayoutFor: self! !

!ClassDescription methodsFor: '*Slot' stamp: 'CAmi 3/15/2011 18:33'!
initializeLayoutWithSlots: slots
	| offset superlayout|
	superlayout := superclass layout.
	offset := superlayout size.
	
	"create the new layout and copy in the super slots"
	layout := self layoutSized: slots size + offset.
	layout replaceFrom: 1 to: offset with: superlayout.
	
	"create new slots"
	slots withIndexDo: [ :slot :index|
		layout at: offset + index put: slot asSlot].
	layout finalize.
	
	"backup solution to create instvar names"
	instanceVariables := Array new: slots size.
	1 to: slots size do: [ :index| 
		instanceVariables at: index put: (layout at: index + offset) name].! !

!ClassDescription methodsFor: '*Slot' stamp: 'CAmi 3/14/2011 19:37'!
layout
	^ layout! !

!ClassDescription methodsFor: '*Slot' stamp: 'CamilloBruni 3/30/2011 19:21'!
layoutSized: size
	|layoutInstance layoutClass|
	layoutClass := PointerLayout.
	
	self isBits
		ifTrue: [
			self isBytes
				ifTrue: [ layoutClass := ByteLayout ].
			self isWords 
				ifTrue: [ layoutClass := WordLayout ]]
		ifFalse: [
			self isVariable ifTrue: [ layoutClass := VariableLayout ].
			self isWeak ifTrue: [ layoutClass := WeakLayout ]].
	
	layoutInstance := layoutClass new: size.
	layoutInstance host: self.
	
	^ layoutInstance! !

!ClassDescription methodsFor: '*Slot' stamp: 'MartinDias 7/30/2012 01:49'!
superclass: aSuperclass layout: aLayout
	layout := aLayout. 
"	layout host: self. --> this is done in #buildFrom:scope:host:"
	
	self
		superclass: aSuperclass
		methodDictionary: MethodDictionary new
		format: aLayout format.
	
	instanceVariables := layout instanceVariables asArray! !

!ClassDescription methodsFor: '*Slot' stamp: 'MartinDias 6/24/2013 16:54'!
superclass: aSuperclass withLayoutType: layoutType slots: slotArray
	| superLayout newScope newLayout |
	superLayout := aSuperclass
						ifNil: [ EmptyLayout instance ]
						ifNotNil: [ aSuperclass layout ].
	newScope := superLayout slotScope extend: slotArray.
	newLayout := layoutType buildFrom: superLayout scope: newScope host: self.
	newLayout checkSanity.
	self
		superclass: aSuperclass
		layout: newLayout! !
